package mhp.oee.po.gen;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ProductionOutputFollowUpPOExample {
    /**
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    protected String orderByClause;

    /**
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    protected boolean distinct;

    /**
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Integer offset;

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public ProductionOutputFollowUpPOExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getOffset() {
        return offset;
    }

    /**
     * This class was generated by MyBatis Generator.
     * This class corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andHandleIsNull() {
            addCriterion("HANDLE is null");
            return (Criteria) this;
        }

        public Criteria andHandleIsNotNull() {
            addCriterion("HANDLE is not null");
            return (Criteria) this;
        }

        public Criteria andHandleEqualTo(String value) {
            addCriterion("HANDLE =", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleNotEqualTo(String value) {
            addCriterion("HANDLE <>", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleGreaterThan(String value) {
            addCriterion("HANDLE >", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleGreaterThanOrEqualTo(String value) {
            addCriterion("HANDLE >=", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleLessThan(String value) {
            addCriterion("HANDLE <", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleLessThanOrEqualTo(String value) {
            addCriterion("HANDLE <=", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleLike(String value) {
            addCriterion("HANDLE like", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleNotLike(String value) {
            addCriterion("HANDLE not like", value, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleIn(List<String> values) {
            addCriterion("HANDLE in", values, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleNotIn(List<String> values) {
            addCriterion("HANDLE not in", values, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleBetween(String value1, String value2) {
            addCriterion("HANDLE between", value1, value2, "handle");
            return (Criteria) this;
        }

        public Criteria andHandleNotBetween(String value1, String value2) {
            addCriterion("HANDLE not between", value1, value2, "handle");
            return (Criteria) this;
        }

        public Criteria andSiteIsNull() {
            addCriterion("SITE is null");
            return (Criteria) this;
        }

        public Criteria andSiteIsNotNull() {
            addCriterion("SITE is not null");
            return (Criteria) this;
        }

        public Criteria andSiteEqualTo(String value) {
            addCriterion("SITE =", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteNotEqualTo(String value) {
            addCriterion("SITE <>", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteGreaterThan(String value) {
            addCriterion("SITE >", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteGreaterThanOrEqualTo(String value) {
            addCriterion("SITE >=", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteLessThan(String value) {
            addCriterion("SITE <", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteLessThanOrEqualTo(String value) {
            addCriterion("SITE <=", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteLike(String value) {
            addCriterion("SITE like", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteNotLike(String value) {
            addCriterion("SITE not like", value, "site");
            return (Criteria) this;
        }

        public Criteria andSiteIn(List<String> values) {
            addCriterion("SITE in", values, "site");
            return (Criteria) this;
        }

        public Criteria andSiteNotIn(List<String> values) {
            addCriterion("SITE not in", values, "site");
            return (Criteria) this;
        }

        public Criteria andSiteBetween(String value1, String value2) {
            addCriterion("SITE between", value1, value2, "site");
            return (Criteria) this;
        }

        public Criteria andSiteNotBetween(String value1, String value2) {
            addCriterion("SITE not between", value1, value2, "site");
            return (Criteria) this;
        }

        public Criteria andResrceIsNull() {
            addCriterion("RESRCE is null");
            return (Criteria) this;
        }

        public Criteria andResrceIsNotNull() {
            addCriterion("RESRCE is not null");
            return (Criteria) this;
        }

        public Criteria andResrceEqualTo(String value) {
            addCriterion("RESRCE =", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceNotEqualTo(String value) {
            addCriterion("RESRCE <>", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceGreaterThan(String value) {
            addCriterion("RESRCE >", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceGreaterThanOrEqualTo(String value) {
            addCriterion("RESRCE >=", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceLessThan(String value) {
            addCriterion("RESRCE <", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceLessThanOrEqualTo(String value) {
            addCriterion("RESRCE <=", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceLike(String value) {
            addCriterion("RESRCE like", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceNotLike(String value) {
            addCriterion("RESRCE not like", value, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceIn(List<String> values) {
            addCriterion("RESRCE in", values, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceNotIn(List<String> values) {
            addCriterion("RESRCE not in", values, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceBetween(String value1, String value2) {
            addCriterion("RESRCE between", value1, value2, "resrce");
            return (Criteria) this;
        }

        public Criteria andResrceNotBetween(String value1, String value2) {
            addCriterion("RESRCE not between", value1, value2, "resrce");
            return (Criteria) this;
        }

        public Criteria andOperationIsNull() {
            addCriterion("OPERATION is null");
            return (Criteria) this;
        }

        public Criteria andOperationIsNotNull() {
            addCriterion("OPERATION is not null");
            return (Criteria) this;
        }

        public Criteria andOperationEqualTo(String value) {
            addCriterion("OPERATION =", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationNotEqualTo(String value) {
            addCriterion("OPERATION <>", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationGreaterThan(String value) {
            addCriterion("OPERATION >", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationGreaterThanOrEqualTo(String value) {
            addCriterion("OPERATION >=", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationLessThan(String value) {
            addCriterion("OPERATION <", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationLessThanOrEqualTo(String value) {
            addCriterion("OPERATION <=", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationLike(String value) {
            addCriterion("OPERATION like", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationNotLike(String value) {
            addCriterion("OPERATION not like", value, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationIn(List<String> values) {
            addCriterion("OPERATION in", values, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationNotIn(List<String> values) {
            addCriterion("OPERATION not in", values, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationBetween(String value1, String value2) {
            addCriterion("OPERATION between", value1, value2, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationNotBetween(String value1, String value2) {
            addCriterion("OPERATION not between", value1, value2, "operation");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionIsNull() {
            addCriterion("OPERATION_REVISION is null");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionIsNotNull() {
            addCriterion("OPERATION_REVISION is not null");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionEqualTo(String value) {
            addCriterion("OPERATION_REVISION =", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionNotEqualTo(String value) {
            addCriterion("OPERATION_REVISION <>", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionGreaterThan(String value) {
            addCriterion("OPERATION_REVISION >", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionGreaterThanOrEqualTo(String value) {
            addCriterion("OPERATION_REVISION >=", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionLessThan(String value) {
            addCriterion("OPERATION_REVISION <", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionLessThanOrEqualTo(String value) {
            addCriterion("OPERATION_REVISION <=", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionLike(String value) {
            addCriterion("OPERATION_REVISION like", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionNotLike(String value) {
            addCriterion("OPERATION_REVISION not like", value, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionIn(List<String> values) {
            addCriterion("OPERATION_REVISION in", values, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionNotIn(List<String> values) {
            addCriterion("OPERATION_REVISION not in", values, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionBetween(String value1, String value2) {
            addCriterion("OPERATION_REVISION between", value1, value2, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andOperationRevisionNotBetween(String value1, String value2) {
            addCriterion("OPERATION_REVISION not between", value1, value2, "operationRevision");
            return (Criteria) this;
        }

        public Criteria andItemIsNull() {
            addCriterion("ITEM is null");
            return (Criteria) this;
        }

        public Criteria andItemIsNotNull() {
            addCriterion("ITEM is not null");
            return (Criteria) this;
        }

        public Criteria andItemEqualTo(String value) {
            addCriterion("ITEM =", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemNotEqualTo(String value) {
            addCriterion("ITEM <>", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemGreaterThan(String value) {
            addCriterion("ITEM >", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemGreaterThanOrEqualTo(String value) {
            addCriterion("ITEM >=", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemLessThan(String value) {
            addCriterion("ITEM <", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemLessThanOrEqualTo(String value) {
            addCriterion("ITEM <=", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemLike(String value) {
            addCriterion("ITEM like", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemNotLike(String value) {
            addCriterion("ITEM not like", value, "item");
            return (Criteria) this;
        }

        public Criteria andItemIn(List<String> values) {
            addCriterion("ITEM in", values, "item");
            return (Criteria) this;
        }

        public Criteria andItemNotIn(List<String> values) {
            addCriterion("ITEM not in", values, "item");
            return (Criteria) this;
        }

        public Criteria andItemBetween(String value1, String value2) {
            addCriterion("ITEM between", value1, value2, "item");
            return (Criteria) this;
        }

        public Criteria andItemNotBetween(String value1, String value2) {
            addCriterion("ITEM not between", value1, value2, "item");
            return (Criteria) this;
        }

        public Criteria andItemRevisionIsNull() {
            addCriterion("ITEM_REVISION is null");
            return (Criteria) this;
        }

        public Criteria andItemRevisionIsNotNull() {
            addCriterion("ITEM_REVISION is not null");
            return (Criteria) this;
        }

        public Criteria andItemRevisionEqualTo(String value) {
            addCriterion("ITEM_REVISION =", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionNotEqualTo(String value) {
            addCriterion("ITEM_REVISION <>", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionGreaterThan(String value) {
            addCriterion("ITEM_REVISION >", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionGreaterThanOrEqualTo(String value) {
            addCriterion("ITEM_REVISION >=", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionLessThan(String value) {
            addCriterion("ITEM_REVISION <", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionLessThanOrEqualTo(String value) {
            addCriterion("ITEM_REVISION <=", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionLike(String value) {
            addCriterion("ITEM_REVISION like", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionNotLike(String value) {
            addCriterion("ITEM_REVISION not like", value, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionIn(List<String> values) {
            addCriterion("ITEM_REVISION in", values, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionNotIn(List<String> values) {
            addCriterion("ITEM_REVISION not in", values, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionBetween(String value1, String value2) {
            addCriterion("ITEM_REVISION between", value1, value2, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andItemRevisionNotBetween(String value1, String value2) {
            addCriterion("ITEM_REVISION not between", value1, value2, "itemRevision");
            return (Criteria) this;
        }

        public Criteria andStrtIsNull() {
            addCriterion("STRT is null");
            return (Criteria) this;
        }

        public Criteria andStrtIsNotNull() {
            addCriterion("STRT is not null");
            return (Criteria) this;
        }

        public Criteria andStrtEqualTo(String value) {
            addCriterion("STRT =", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtNotEqualTo(String value) {
            addCriterion("STRT <>", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtGreaterThan(String value) {
            addCriterion("STRT >", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtGreaterThanOrEqualTo(String value) {
            addCriterion("STRT >=", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtLessThan(String value) {
            addCriterion("STRT <", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtLessThanOrEqualTo(String value) {
            addCriterion("STRT <=", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtLike(String value) {
            addCriterion("STRT like", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtNotLike(String value) {
            addCriterion("STRT not like", value, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtIn(List<String> values) {
            addCriterion("STRT in", values, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtNotIn(List<String> values) {
            addCriterion("STRT not in", values, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtBetween(String value1, String value2) {
            addCriterion("STRT between", value1, value2, "strt");
            return (Criteria) this;
        }

        public Criteria andStrtNotBetween(String value1, String value2) {
            addCriterion("STRT not between", value1, value2, "strt");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoIsNull() {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO is null");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoIsNotNull() {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO is not null");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoEqualTo(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO =", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoNotEqualTo(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO <>", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoGreaterThan(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO >", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoGreaterThanOrEqualTo(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO >=", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoLessThan(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO <", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoLessThanOrEqualTo(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO <=", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoLike(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO like", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoNotLike(String value) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO not like", value, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoIn(List<String> values) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO in", values, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoNotIn(List<String> values) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO not in", values, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoBetween(String value1, String value2) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO between", value1, value2, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andProductionOutputFirstBoNotBetween(String value1, String value2) {
            addCriterion("PRODUCTION_OUTPUT_FIRST_BO not between", value1, value2, "productionOutputFirstBo");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeIsNull() {
            addCriterion("START_DATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeIsNotNull() {
            addCriterion("START_DATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeEqualTo(Date value) {
            addCriterion("START_DATE_TIME =", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeNotEqualTo(Date value) {
            addCriterion("START_DATE_TIME <>", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeGreaterThan(Date value) {
            addCriterion("START_DATE_TIME >", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("START_DATE_TIME >=", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeLessThan(Date value) {
            addCriterion("START_DATE_TIME <", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeLessThanOrEqualTo(Date value) {
            addCriterion("START_DATE_TIME <=", value, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeIn(List<Date> values) {
            addCriterion("START_DATE_TIME in", values, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeNotIn(List<Date> values) {
            addCriterion("START_DATE_TIME not in", values, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeBetween(Date value1, Date value2) {
            addCriterion("START_DATE_TIME between", value1, value2, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andStartDateTimeNotBetween(Date value1, Date value2) {
            addCriterion("START_DATE_TIME not between", value1, value2, "startDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeIsNull() {
            addCriterion("END_DATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeIsNotNull() {
            addCriterion("END_DATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeEqualTo(Date value) {
            addCriterion("END_DATE_TIME =", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeNotEqualTo(Date value) {
            addCriterion("END_DATE_TIME <>", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeGreaterThan(Date value) {
            addCriterion("END_DATE_TIME >", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("END_DATE_TIME >=", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeLessThan(Date value) {
            addCriterion("END_DATE_TIME <", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeLessThanOrEqualTo(Date value) {
            addCriterion("END_DATE_TIME <=", value, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeIn(List<Date> values) {
            addCriterion("END_DATE_TIME in", values, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeNotIn(List<Date> values) {
            addCriterion("END_DATE_TIME not in", values, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeBetween(Date value1, Date value2) {
            addCriterion("END_DATE_TIME between", value1, value2, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andEndDateTimeNotBetween(Date value1, Date value2) {
            addCriterion("END_DATE_TIME not between", value1, value2, "endDateTime");
            return (Criteria) this;
        }

        public Criteria andShiftIsNull() {
            addCriterion("SHIFT is null");
            return (Criteria) this;
        }

        public Criteria andShiftIsNotNull() {
            addCriterion("SHIFT is not null");
            return (Criteria) this;
        }

        public Criteria andShiftEqualTo(String value) {
            addCriterion("SHIFT =", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftNotEqualTo(String value) {
            addCriterion("SHIFT <>", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftGreaterThan(String value) {
            addCriterion("SHIFT >", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftGreaterThanOrEqualTo(String value) {
            addCriterion("SHIFT >=", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftLessThan(String value) {
            addCriterion("SHIFT <", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftLessThanOrEqualTo(String value) {
            addCriterion("SHIFT <=", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftLike(String value) {
            addCriterion("SHIFT like", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftNotLike(String value) {
            addCriterion("SHIFT not like", value, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftIn(List<String> values) {
            addCriterion("SHIFT in", values, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftNotIn(List<String> values) {
            addCriterion("SHIFT not in", values, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftBetween(String value1, String value2) {
            addCriterion("SHIFT between", value1, value2, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftNotBetween(String value1, String value2) {
            addCriterion("SHIFT not between", value1, value2, "shift");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionIsNull() {
            addCriterion("SHIFT_DESCRIPTION is null");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionIsNotNull() {
            addCriterion("SHIFT_DESCRIPTION is not null");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionEqualTo(String value) {
            addCriterion("SHIFT_DESCRIPTION =", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionNotEqualTo(String value) {
            addCriterion("SHIFT_DESCRIPTION <>", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionGreaterThan(String value) {
            addCriterion("SHIFT_DESCRIPTION >", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("SHIFT_DESCRIPTION >=", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionLessThan(String value) {
            addCriterion("SHIFT_DESCRIPTION <", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionLessThanOrEqualTo(String value) {
            addCriterion("SHIFT_DESCRIPTION <=", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionLike(String value) {
            addCriterion("SHIFT_DESCRIPTION like", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionNotLike(String value) {
            addCriterion("SHIFT_DESCRIPTION not like", value, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionIn(List<String> values) {
            addCriterion("SHIFT_DESCRIPTION in", values, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionNotIn(List<String> values) {
            addCriterion("SHIFT_DESCRIPTION not in", values, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionBetween(String value1, String value2) {
            addCriterion("SHIFT_DESCRIPTION between", value1, value2, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andShiftDescriptionNotBetween(String value1, String value2) {
            addCriterion("SHIFT_DESCRIPTION not between", value1, value2, "shiftDescription");
            return (Criteria) this;
        }

        public Criteria andQtyYieldIsNull() {
            addCriterion("QTY_YIELD is null");
            return (Criteria) this;
        }

        public Criteria andQtyYieldIsNotNull() {
            addCriterion("QTY_YIELD is not null");
            return (Criteria) this;
        }

        public Criteria andQtyYieldEqualTo(BigDecimal value) {
            addCriterion("QTY_YIELD =", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldNotEqualTo(BigDecimal value) {
            addCriterion("QTY_YIELD <>", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldGreaterThan(BigDecimal value) {
            addCriterion("QTY_YIELD >", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_YIELD >=", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldLessThan(BigDecimal value) {
            addCriterion("QTY_YIELD <", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldLessThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_YIELD <=", value, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldIn(List<BigDecimal> values) {
            addCriterion("QTY_YIELD in", values, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldNotIn(List<BigDecimal> values) {
            addCriterion("QTY_YIELD not in", values, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_YIELD between", value1, value2, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyYieldNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_YIELD not between", value1, value2, "qtyYield");
            return (Criteria) this;
        }

        public Criteria andQtyScrapIsNull() {
            addCriterion("QTY_SCRAP is null");
            return (Criteria) this;
        }

        public Criteria andQtyScrapIsNotNull() {
            addCriterion("QTY_SCRAP is not null");
            return (Criteria) this;
        }

        public Criteria andQtyScrapEqualTo(BigDecimal value) {
            addCriterion("QTY_SCRAP =", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapNotEqualTo(BigDecimal value) {
            addCriterion("QTY_SCRAP <>", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapGreaterThan(BigDecimal value) {
            addCriterion("QTY_SCRAP >", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_SCRAP >=", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapLessThan(BigDecimal value) {
            addCriterion("QTY_SCRAP <", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapLessThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_SCRAP <=", value, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapIn(List<BigDecimal> values) {
            addCriterion("QTY_SCRAP in", values, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapNotIn(List<BigDecimal> values) {
            addCriterion("QTY_SCRAP not in", values, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_SCRAP between", value1, value2, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyScrapNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_SCRAP not between", value1, value2, "qtyScrap");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmIsNull() {
            addCriterion("QTY_UNCONFIRM is null");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmIsNotNull() {
            addCriterion("QTY_UNCONFIRM is not null");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmEqualTo(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM =", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmNotEqualTo(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM <>", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmGreaterThan(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM >", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM >=", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmLessThan(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM <", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmLessThanOrEqualTo(BigDecimal value) {
            addCriterion("QTY_UNCONFIRM <=", value, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmIn(List<BigDecimal> values) {
            addCriterion("QTY_UNCONFIRM in", values, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmNotIn(List<BigDecimal> values) {
            addCriterion("QTY_UNCONFIRM not in", values, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_UNCONFIRM between", value1, value2, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andQtyUnconfirmNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("QTY_UNCONFIRM not between", value1, value2, "qtyUnconfirm");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeIsNull() {
            addCriterion("CREATED_DATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeIsNotNull() {
            addCriterion("CREATED_DATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeEqualTo(Date value) {
            addCriterion("CREATED_DATE_TIME =", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeNotEqualTo(Date value) {
            addCriterion("CREATED_DATE_TIME <>", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeGreaterThan(Date value) {
            addCriterion("CREATED_DATE_TIME >", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATED_DATE_TIME >=", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeLessThan(Date value) {
            addCriterion("CREATED_DATE_TIME <", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATED_DATE_TIME <=", value, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeIn(List<Date> values) {
            addCriterion("CREATED_DATE_TIME in", values, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeNotIn(List<Date> values) {
            addCriterion("CREATED_DATE_TIME not in", values, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATED_DATE_TIME between", value1, value2, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andCreatedDateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATED_DATE_TIME not between", value1, value2, "createdDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeIsNull() {
            addCriterion("MODIFIED_DATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeIsNotNull() {
            addCriterion("MODIFIED_DATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeEqualTo(Date value) {
            addCriterion("MODIFIED_DATE_TIME =", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeNotEqualTo(Date value) {
            addCriterion("MODIFIED_DATE_TIME <>", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeGreaterThan(Date value) {
            addCriterion("MODIFIED_DATE_TIME >", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("MODIFIED_DATE_TIME >=", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeLessThan(Date value) {
            addCriterion("MODIFIED_DATE_TIME <", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeLessThanOrEqualTo(Date value) {
            addCriterion("MODIFIED_DATE_TIME <=", value, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeIn(List<Date> values) {
            addCriterion("MODIFIED_DATE_TIME in", values, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeNotIn(List<Date> values) {
            addCriterion("MODIFIED_DATE_TIME not in", values, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeBetween(Date value1, Date value2) {
            addCriterion("MODIFIED_DATE_TIME between", value1, value2, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedDateTimeNotBetween(Date value1, Date value2) {
            addCriterion("MODIFIED_DATE_TIME not between", value1, value2, "modifiedDateTime");
            return (Criteria) this;
        }

        public Criteria andModifiedUserIsNull() {
            addCriterion("MODIFIED_USER is null");
            return (Criteria) this;
        }

        public Criteria andModifiedUserIsNotNull() {
            addCriterion("MODIFIED_USER is not null");
            return (Criteria) this;
        }

        public Criteria andModifiedUserEqualTo(String value) {
            addCriterion("MODIFIED_USER =", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserNotEqualTo(String value) {
            addCriterion("MODIFIED_USER <>", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserGreaterThan(String value) {
            addCriterion("MODIFIED_USER >", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserGreaterThanOrEqualTo(String value) {
            addCriterion("MODIFIED_USER >=", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserLessThan(String value) {
            addCriterion("MODIFIED_USER <", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserLessThanOrEqualTo(String value) {
            addCriterion("MODIFIED_USER <=", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserLike(String value) {
            addCriterion("MODIFIED_USER like", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserNotLike(String value) {
            addCriterion("MODIFIED_USER not like", value, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserIn(List<String> values) {
            addCriterion("MODIFIED_USER in", values, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserNotIn(List<String> values) {
            addCriterion("MODIFIED_USER not in", values, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserBetween(String value1, String value2) {
            addCriterion("MODIFIED_USER between", value1, value2, "modifiedUser");
            return (Criteria) this;
        }

        public Criteria andModifiedUserNotBetween(String value1, String value2) {
            addCriterion("MODIFIED_USER not between", value1, value2, "modifiedUser");
            return (Criteria) this;
        }
    }

    /**
     * This class was generated by MyBatis Generator.
     * This class corresponds to the database table production_output_follow_up
     *
     * @mbggenerated do_not_delete_during_merge
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * This class was generated by MyBatis Generator.
     * This class corresponds to the database table production_output_follow_up
     *
     * @mbggenerated
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}